tdSymfony/src/Entity/Album.php
<?php

namespace App\Entity;

use App\Repository\AlbumRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: AlbumRepository::class)]
class Album
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(length: 255)]
    private ?string $title = null;

    #[ORM\Column(length: 255, nullable: true)]
    private ?string $cover = null;

    #[ORM\Column]
    private ?int $nb_track = null;

    #[ORM\Column(length: 255, nullable: true)]
    private ?string $release_date = null;

    #[ORM\ManyToMany(targetEntity: Musique::class, inversedBy: 'albums')]
    private Collection $musiquelist;

    #[ORM\ManyToMany(targetEntity: Autheur::class, inversedBy: 'albums')]
    private Collection $autheur;

    public function __construct()
    {
        $this->musiquelist = new ArrayCollection();
        $this->autheur = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getTitle(): ?string
    {
        return $this->title;
    }

    public function setTitle(string $title): self
    {
        $this->title = $title;

        return $this;
    }

    public function getCover(): ?string
    {
        return $this->cover;
    }

    public function setCover(?string $cover): self
    {
        $this->cover = $cover;

        return $this;
    }

    public function getNbTrack(): ?int
    {
        return $this->nb_track;
    }

    public function setNbTrack(int $nb_track): self
    {
        $this->nb_track = $nb_track;

        return $this;
    }

    public function getReleaseDate(): ?string
    {
        return $this->release_date;
    }

    public function setReleaseDate(?string $release_date): self
    {
        $this->release_date = $release_date;

        return $this;
    }

    /**
     * @return Collection<int, Musique>
     */
    public function getMusiquelist(): Collection
    {
        return $this->musiquelist;
    }

    public function addMusiquelist(Musique $musiquelist): self
    {
        if (!$this->musiquelist->contains($musiquelist)) {
            $this->musiquelist->add($musiquelist);
        }

        return $this;
    }

    public function removeMusiquelist(Musique $musiquelist): self
    {
        $this->musiquelist->removeElement($musiquelist);

        return $this;
    }

    /**
     * @return Collection<int, Autheur>
     */
    public function getAutheur(): Collection
    {
        return $this->autheur;
    }

    public function addAutheur(Autheur $autheur): self
    {
        if (!$this->autheur->contains($autheur)) {
            $this->autheur->add($autheur);
        }

        return $this;
    }

    public function removeAutheur(Autheur $autheur): self
    {
        $this->autheur->removeElement($autheur);

        return $this;
    }
}

tdSymfony/src/Entity/Autheur.php
<?php

namespace App\Entity;

use App\Repository\AutheurRepository;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: AutheurRepository::class)]
class Autheur
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(length: 255)]
    private ?string $Nom = null;

    #[ORM\Column(length: 255)]
    private ?string $Prenom = null;

    #[ORM\ManyToMany(targetEntity: Musique::class, mappedBy: 'Autheur')]
    private Collection $musiques;

    #[ORM\ManyToMany(targetEntity: Album::class, mappedBy: 'autheur')]
    private Collection $albums;

    public function __construct()
    {
        $this->musiques = new ArrayCollection();
        $this->albums = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getNom(): ?string
    {
        return $this->Nom;
    }

    public function setNom(string $Nom): self
    {
        $this->Nom = $Nom;

        return $this;
    }

    public function getPrenom(): ?string
    {
        return $this->Prenom;
    }

    public function setPrenom(string $Prenom): self
    {
        $this->Prenom = $Prenom;

        return $this;
    }

    /**
     * @return Collection<int, Musique>
     */
    public function getMusiques(): Collection
    {
        return $this->musiques;
    }

    public function addMusique(Musique $musique): self
    {
        if (!$this->musiques->contains($musique)) {
            $this->musiques->add($musique);
            $musique->addAutheur($this);
        }

        return $this;
    }

    public function removeMusique(Musique $musique): self
    {
        if ($this->musiques->removeElement($musique)) {
            $musique->removeAutheur($this);
        }

        return $this;
    }

    /**
     * @return Collection<int, Album>
     */
    public function getAlbums(): Collection
    {
        return $this->albums;
    }

    public function addAlbum(Album $album): self
    {
        if (!$this->albums->contains($album)) {
            $this->albums->add($album);
            $album->addAutheur($this);
        }

        return $this;
    }

    public function removeAlbum(Album $album): self
    {
        if ($this->albums->removeElement($album)) {
            $album->removeAutheur($this);
        }

        return $this;
    }
}

tdSymfony/src/Form/AlbumType.php
<?php

namespace App\Form;

use App\Entity\Album;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class AlbumType extends AbstractType
{
    public function buildForm(FormBuilderInterface $builder, array $options): void
    {
        $builder
            ->add('title')
            ->add('cover')
            ->add('nb_track')
            ->add('release_date')
        ;
    }

    public function configureOptions(OptionsResolver $resolver): void
    {
        $resolver->setDefaults([
            'data_class' => Album::class,
        ]);
    }
}

tdSymfony/src/Controller/AlbumController.php
<?php

namespace App\Controller;

use App\Entity\Album;
use App\Form\AlbumType;
use App\Repository\AlbumRepository;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\Routing\Annotation\Route;

#[Route('/album')]
class AlbumController extends AbstractController
{
    #[Route('/', name: 'app_album_index', methods: ['GET'])]
    public function index(AlbumRepository $albumRepository): Response
    {
        return $this->render('album/index.html.twig', [
            'albums' => $albumRepository->findAll(),
        ]);
    }

    #[Route('/new', name: 'app_album_new', methods: ['GET', 'POST'])]
    public function new(Request $request, AlbumRepository $albumRepository): Response
    {
        $album = new Album();
        $form = $this->createForm(AlbumType::class, $album);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $albumRepository->save($album, true);

            return $this->redirectToRoute('app_album_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('album/new.html.twig', [
            'album' => $album,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_album_show', methods: ['GET'])]
    public function show(Album $album): Response
    {
        return $this->render('album/show.html.twig', [
            'album' => $album,
        ]);
    }

    #[Route('/{id}/edit', name: 'app_album_edit', methods: ['GET', 'POST'])]
    public function edit(Request $request, Album $album, AlbumRepository $albumRepository): Response
    {
        $form = $this->createForm(AlbumType::class, $album);
        $form->handleRequest($request);

        if ($form->isSubmitted() && $form->isValid()) {
            $albumRepository->save($album, true);

            return $this->redirectToRoute('app_album_index', [], Response::HTTP_SEE_OTHER);
        }

        return $this->renderForm('album/edit.html.twig', [
            'album' => $album,
            'form' => $form,
        ]);
    }

    #[Route('/{id}', name: 'app_album_delete', methods: ['POST'])]
    public function delete(Request $request, Album $album, AlbumRepository $albumRepository): Response
    {
        if ($this->isCsrfTokenValid('delete'.$album->getId(), $request->request->get('_token'))) {
            $albumRepository->remove($album, true);
        }

        return $this->redirectToRoute('app_album_index', [], Response::HTTP_SEE_OTHER);
    }
}

tdSymfony/templates/album/_delete_form.html.twig
<form method="post" action="{{ path('app_album_delete', {'id': album.id}) }}" onsubmit="return confirm('Are you sure you want to delete this item?');">
    <input type="hidden" name="_token" value="{{ csrf_token('delete' ~ album.id) }}">
    <button class="btn btn-danger">Delete</button>
</form>

tdSymfony/templates/album/_form.html.twig
{{ form_start(form) }}
    {{ form_widget(form) }}
    <button class="btn">{{ button_label|default('Save') }}</button>
{{ form_end(form) }}

tdSymfony/templates/album/edit.html.twig
{% extends 'base.html.twig' %}

{% block title %}Edit Album{% endblock %}

{% block body %}
    <h1>Edit Album</h1>

    {{ include('album/_form.html.twig', {'button_label': 'Update'}) }}

    <a class="btn btn-primary" href="{{ path('app_album_index') }}">back to list</a>

    {{ include('album/_delete_form.html.twig') }}
{% endblock %}

tdSymfony/templates/album/index.html.twig
{% extends 'base.html.twig' %}

{% block title %}Album index{% endblock %}

{% block body %}
    <style>
        img{
            max-width: 100px;
            max-height: 100px;
            width: 100px;
            height: 100px;
        }
        th,td{
            text-align: center
        }
    </style>
    <h1>Album index</h1>

    <table class="table">
        <thead>
            <tr>
                <th>Id</th>
                <th>Title</th>
                <th>Cover</th>
                <th>Nb_track</th>
                <th>Release_date</th>
                {# <th>Auteurs</th> #}
                <th>actions</th>
            </tr>
        </thead>
        <tbody>
        {% for album in albums %}
            <tr>
                <td>{{ album.id }}</td>
                <td>{{ album.title }}</td>
                <td><img src="{{ album.cover }}" alt="jaquette album"></td>
                <td>{{ album.nbTrack }}</td>
                <td>{{ album.releaseDate }}</td>
                {# <td>
                {% for album in album.autheur %}
                    <a href="/autheur/{{ album.id }}">{{ album.nom }}</a>
                {% endfor %}
                </td> #}
                <td>
                    <a class="btn btn-info" href="{{ path('app_album_show', {'id': album.id}) }}">show</a>
                    <a class="btn btn-warning" href="{{ path('app_album_edit', {'id': album.id}) }}">edit</a>
                </td>
            </tr>
        {% else %}
            <tr>
                <td colspan="6">no records found</td>
            </tr>
        {% endfor %}
        </tbody>
    </table>

    <a class="btn btn-primary" href="{{ path('app_album_new') }}">Create new</a>

        <script>
      $(document).ready(function () {
          $('.table').DataTable(
              {
                  "language": {
                      "sProcessing": "Traitement en cours...",
                      "sLengthMenu": "Afficher _MENU_ lignes",
                      "sZeroRecords": "Aucun résultat trouvé",
                      "sEmptyTable": "Aucune donnée disponible dans cette table",
                      "sInfo": "Afficher les lignes de _START_ à _END_ sur un total de _TOTAL_ lignes",
                      "sInfoEmpty": "Afficher les lignes de 0 à 0 sur un total de 0 lignes",
                      "sInfoFiltered": "(a filtré un total de _MAX_ lignes)",
                      "sInfoPostFix": "",
                      "sSearch": "Rechercher :",
                      "url": "",
                      "sInfoThousands": ",",
                      "sLoadingRecords": "Chargement...",
                      "oPaginer": {
                          "sFirst": "Premier",
                          "sLast": "Dernier",
                          "sNext": "Suivant",
                          "sPrevious": "Précédent"
                      },
                      "oAria": {
                          "sSortAscending": ": Trier par ordre croissant",
                          "sSortDescending": ": Trier par ordre décroissant"
                      }
                  }
              }
          );
      });

      function redirect_inviter() {
          window.location.href = "/secret/inviter";
      }
    </script>
{% endblock %}

tdSymfony/templates/album/new.html.twig
{% extends 'base.html.twig' %}

{% block title %}New Album{% endblock %}

{% block body %}
    <h1>Create new Album</h1>

    {{ include('album/_form.html.twig') }}

    <a class="btn btn-primary" href="{{ path('app_album_index') }}">back to list</a>
{% endblock %}

tdSymfony/templates/album/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}Album{% endblock %}

{% block body %}
    <h1>Album</h1>

    <table class="table">
        <tbody>
            <tr>
                <th>Id</th>
                <td>{{ album.id }}</td>
            </tr>
            <tr>
                <th>Title</th>
                <td>{{ album.title }}</td>
            </tr>
            <tr>
                <th>Cover</th>
                <td>{{ album.cover }}</td>
            </tr>
            <tr>
                <th>Nb_track</th>
                <td>{{ album.nbTrack }}</td>
            </tr>
            <tr>
                <th>Release_date</th>
                <td>{{ album.releaseDate }}</td>
            </tr>
            <tr>
                <th>Musiques</th>
                {% for musique in album.musiquelist %}
                
                    
                    <td><td><img src="{{ musique.Image }}" alt="jaquette album"><audio src="{{musique.son}}" controls>
                        Votre navigateur ne semble pas supporter ce fichier
                    </audio></td>
                    
                    
                    </td>
                
                    {% endfor %}
            </tr>
        </tbody>
    </table>

    <a class="btn btn-primary" href="{{ path('app_album_index') }}">back to list</a>

    <a class="btn btn-warning" href="{{ path('app_album_edit', {'id': album.id}) }}">edit</a>

    {{ include('album/_delete_form.html.twig') }}
{% endblock %}